First Add

This commit is contained in:
root
2024-03-06 15:21:38 +01:00
commit e4d888ce1d
570 changed files with 229039 additions and 0 deletions
+539
View File
@@ -0,0 +1,539 @@
# Makefile.in generated by automake 1.13.4 from Makefile.am.
# compat/Makefile. Generated from Makefile.in by configure.
# Copyright (C) 1994-2013 Free Software Foundation, Inc.
# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.
am__is_gnu_make = test -n '$(MAKEFILE_LIST)' && test -n '$(MAKELEVEL)'
am__make_running_with_option = \
case $${target_option-} in \
?) ;; \
*) echo "am__make_running_with_option: internal error: invalid" \
"target option '$${target_option-}' specified" >&2; \
exit 1;; \
esac; \
has_opt=no; \
sane_makeflags=$$MAKEFLAGS; \
if $(am__is_gnu_make); then \
sane_makeflags=$$MFLAGS; \
else \
case $$MAKEFLAGS in \
*\\[\ \ ]*) \
bs=\\; \
sane_makeflags=`printf '%s\n' "$$MAKEFLAGS" \
| sed "s/$$bs$$bs[$$bs $$bs ]*//g"`;; \
esac; \
fi; \
skip_next=no; \
strip_trailopt () \
{ \
flg=`printf '%s\n' "$$flg" | sed "s/$$1.*$$//"`; \
}; \
for flg in $$sane_makeflags; do \
test $$skip_next = yes && { skip_next=no; continue; }; \
case $$flg in \
*=*|--*) continue;; \
-*I) strip_trailopt 'I'; skip_next=yes;; \
-*I?*) strip_trailopt 'I';; \
-*O) strip_trailopt 'O'; skip_next=yes;; \
-*O?*) strip_trailopt 'O';; \
-*l) strip_trailopt 'l'; skip_next=yes;; \
-*l?*) strip_trailopt 'l';; \
-[dEDm]) skip_next=yes;; \
-[JT]) skip_next=yes;; \
esac; \
case $$flg in \
*$$target_option*) has_opt=yes; break;; \
esac; \
done; \
test $$has_opt = yes
am__make_dryrun = (target_option=n; $(am__make_running_with_option))
am__make_keepgoing = (target_option=k; $(am__make_running_with_option))
pkgdatadir = $(datadir)/genders
pkgincludedir = $(includedir)/genders
pkglibdir = $(libdir)/genders
pkglibexecdir = $(libexecdir)/genders
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
build_triplet = x86_64-unknown-linux-gnu
host_triplet = x86_64-unknown-linux-gnu
target_triplet = x86_64-unknown-linux-gnu
subdir = compat
DIST_COMMON = $(srcdir)/Makefile.in $(srcdir)/Makefile.am
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/config/ac_cplusplus_extensions.m4 \
$(top_srcdir)/config/ac_debug.m4 \
$(top_srcdir)/config/ac_extension_destdir.m4 \
$(top_srcdir)/config/ac_genders_file.m4 \
$(top_srcdir)/config/ac_java_extenions.m4 \
$(top_srcdir)/config/ac_meta.m4 \
$(top_srcdir)/config/ac_perl_extensions.m4 \
$(top_srcdir)/config/ac_perl_site_arch.m4 \
$(top_srcdir)/config/ac_perl_vendor_arch.m4 \
$(top_srcdir)/config/ac_python_extensions.m4 \
$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
$(ACLOCAL_M4)
mkinstalldirs = $(install_sh) -d
CONFIG_HEADER = $(top_builddir)/config/config.h
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
am__vpath_adj = case $$p in \
$(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
*) f=$$p;; \
esac;
am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
am__install_max = 40
am__nobase_strip_setup = \
srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
am__nobase_strip = \
for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
am__nobase_list = $(am__nobase_strip_setup); \
for p in $$list; do echo "$$p $$p"; done | \
sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
$(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
if (++n[$$2] == $(am__install_max)) \
{ print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
END { for (dir in files) print dir, files[dir] }'
am__base_list = \
sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
am__uninstall_files_from_dir = { \
test -z "$$files" \
|| { test ! -d "$$dir" && test ! -f "$$dir" && test ! -r "$$dir"; } \
|| { echo " ( cd '$$dir' && rm -f" $$files ")"; \
$(am__cd) "$$dir" && rm -f $$files; }; \
}
am__installdirs = "$(DESTDIR)$(gendlibdir)"
SCRIPTS = $(gendlib_SCRIPTS)
AM_V_P = $(am__v_P_$(V))
am__v_P_ = $(am__v_P_$(AM_DEFAULT_VERBOSITY))
am__v_P_0 = false
am__v_P_1 = :
AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo " GEN " $@;
am__v_GEN_1 =
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
am__v_at_1 =
SOURCES =
DIST_SOURCES =
am__can_run_installinfo = \
case $$AM_UPDATE_INFO_DIR in \
n|no|NO) false;; \
*) (install-info --version) >/dev/null 2>&1;; \
esac
am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) $(LISP)
DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
ACLOCAL = aclocal-1.13
AMTAR = $${TAR-tar}
AM_DEFAULT_VERBOSITY = 1
AR = ar
AUTOCONF = autoconf
AUTOHEADER = autoheader
AUTOMAKE = automake-1.13
AWK = mawk
CC = gcc
CCDEPMODE = depmode=gcc3
CFLAGS = -O3 -Wall -fno-strict-aliasing
CPP = gcc -E
CPPFLAGS =
CXX = g++
CXXCPP = g++ -E
CXXDEPMODE = depmode=gcc3
CXXFLAGS = -g -O2
CYGPATH_W = echo
DEFS = -DHAVE_CONFIG_H
DEPDIR = .deps
DLLTOOL = false
DSYMUTIL =
DUMPBIN =
ECHO_C =
ECHO_N = -n
ECHO_T =
EGREP = /usr/bin/grep -E
EXEEXT =
EXTENSION_DESTDIR =
FGREP = /usr/bin/grep -F
FORCE_YACC =
GENDERS_DEFAULT_FILE = "/etc/genders"
GREP = /usr/bin/grep
INSTALL = /usr/bin/install -c
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_PROGRAM = ${INSTALL}
INSTALL_SCRIPT = ${INSTALL}
INSTALL_STRIP_PROGRAM = $(install_sh) -c -s
JAR = /usr/bin/jar
JAVA = /usr/bin/java
JAVAC = /usr/bin/javac
JAVADOC = /usr/bin/javadoc
JAVAH =
LD = /usr/bin/ld -m elf_x86_64
LDFLAGS =
LEX = flex
LEXLIB = -lfl
LEX_OUTPUT_ROOT = lex.yy
LIBGENDERSJNI_VERSION_INFO = 0:0:0
LIBGENDERSPLUSPLUS_VERSION_INFO = 2:0:0
LIBGENDERS_VERSION_INFO = 3:3:3
LIBOBJS =
LIBS =
LIBTOOL = $(SHELL) $(top_builddir)/libtool
LIPO =
LN_S = ln -s
LTLIBOBJS =
MAINT = #
MAKEINFO = makeinfo
MANIFEST_TOOL = :
MANPAGE_DEBUG = 0
MKDIR_P = /usr/bin/mkdir -p
NM = /usr/bin/nm -B
NMEDIT =
OBJDUMP = objdump
OBJEXT = o
OTOOL =
OTOOL64 =
PACKAGE = genders
PACKAGE_BUGREPORT =
PACKAGE_NAME = genders
PACKAGE_STRING = genders 1.28
PACKAGE_TARNAME = genders
PACKAGE_URL =
PACKAGE_VERSION = 1.28
PATH_SEPARATOR = :
PERL = /usr/bin/perl
PERLGENDERS_VERSION = 0.03
PERLMAN3EXT = 3pm
PERL_ARCH_INSTALL = vendor
POD2MAN = /usr/bin/pod2man
PROJECT = genders
PYTHON =
PYTHONGENDERS_VERSION = 1.2
RANLIB = ranlib
RELEASE = 1
SED = /usr/bin/sed
SET_MAKE =
SHELL = /bin/bash
STRIP = strip
VERSION = 1.28
YACC = byacc
YFLAGS =
abs_builddir = /home/local/DEVEL/genders-master/compat
abs_srcdir = /home/local/DEVEL/genders-master/compat
abs_top_builddir = /home/local/DEVEL/genders-master
abs_top_srcdir = /home/local/DEVEL/genders-master
ac_ct_AR = ar
ac_ct_CC = gcc
ac_ct_CXX = g++
ac_ct_DUMPBIN =
am__include = include
am__leading_dot = .
am__quote =
am__tar = tar --format=ustar -chf - "$$tardir"
am__untar = tar -xf -
bindir = ${exec_prefix}/bin
build = x86_64-unknown-linux-gnu
build_alias =
build_cpu = x86_64
build_os = linux-gnu
build_vendor = unknown
builddir = .
datadir = ${datarootdir}
datarootdir = ${prefix}/share
docdir = ${datarootdir}/doc/${PACKAGE_TARNAME}
dvidir = ${docdir}
exec_prefix = ${prefix}
host = x86_64-unknown-linux-gnu
host_alias =
host_cpu = x86_64
host_os = linux-gnu
host_vendor = unknown
htmldir = ${docdir}
includedir = ${prefix}/include
infodir = ${datarootdir}/info
install_sh = ${SHELL} /home/local/DEVEL/genders-master/config/install-sh
libdir = ${exec_prefix}/lib
libexecdir = ${exec_prefix}/libexec
localedir = ${datarootdir}/locale
localstatedir = ${prefix}/var
mandir = ${datarootdir}/man
mkdir_p = $(MKDIR_P)
oldincludedir = /usr/include
pdfdir = ${docdir}
prefix = /home/local/PREFIX
program_transform_name = s,x,x,
psdir = ${docdir}
sbindir = ${exec_prefix}/sbin
sharedstatedir = ${prefix}/com
srcdir = .
sysconfdir = ${prefix}/etc
target = x86_64-unknown-linux-gnu
target_alias =
target_cpu = x86_64
target_os = linux-gnu
target_vendor = unknown
top_build_prefix = ../
top_builddir = ..
top_srcdir = ..
# Don't use ${libdir}, the /lib is a legacy path that must be maintained
gendlibdir = ${prefix}/lib/genders
gendlib_SCRIPTS = gendlib.pl hostlist.pl
EXTRA_DIST = gendlib.pl hostlist.pl
all: all-am
.SUFFIXES:
$(srcdir)/Makefile.in: # $(srcdir)/Makefile.am $(am__configure_deps)
@for dep in $?; do \
case '$(am__configure_deps)' in \
*$$dep*) \
( cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh ) \
&& { if test -f $@; then exit 0; else break; fi; }; \
exit 1;; \
esac; \
done; \
echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu compat/Makefile'; \
$(am__cd) $(top_srcdir) && \
$(AUTOMAKE) --gnu compat/Makefile
.PRECIOUS: Makefile
Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
@case '$?' in \
*config.status*) \
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
*) \
echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe)'; \
cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe);; \
esac;
$(top_builddir)/config.status: $(top_srcdir)/configure $(CONFIG_STATUS_DEPENDENCIES)
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(top_srcdir)/configure: # $(am__configure_deps)
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(ACLOCAL_M4): # $(am__aclocal_m4_deps)
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(am__aclocal_m4_deps):
install-gendlibSCRIPTS: $(gendlib_SCRIPTS)
@$(NORMAL_INSTALL)
@list='$(gendlib_SCRIPTS)'; test -n "$(gendlibdir)" || list=; \
if test -n "$$list"; then \
echo " $(MKDIR_P) '$(DESTDIR)$(gendlibdir)'"; \
$(MKDIR_P) "$(DESTDIR)$(gendlibdir)" || exit 1; \
fi; \
for p in $$list; do \
if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
if test -f "$$d$$p"; then echo "$$d$$p"; echo "$$p"; else :; fi; \
done | \
sed -e 'p;s,.*/,,;n' \
-e 'h;s|.*|.|' \
-e 'p;x;s,.*/,,;$(transform)' | sed 'N;N;N;s,\n, ,g' | \
$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1; } \
{ d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
if ($$2 == $$4) { files[d] = files[d] " " $$1; \
if (++n[d] == $(am__install_max)) { \
print "f", d, files[d]; n[d] = 0; files[d] = "" } } \
else { print "f", d "/" $$4, $$1 } } \
END { for (d in files) print "f", d, files[d] }' | \
while read type dir files; do \
if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
test -z "$$files" || { \
echo " $(INSTALL_SCRIPT) $$files '$(DESTDIR)$(gendlibdir)$$dir'"; \
$(INSTALL_SCRIPT) $$files "$(DESTDIR)$(gendlibdir)$$dir" || exit $$?; \
} \
; done
uninstall-gendlibSCRIPTS:
@$(NORMAL_UNINSTALL)
@list='$(gendlib_SCRIPTS)'; test -n "$(gendlibdir)" || exit 0; \
files=`for p in $$list; do echo "$$p"; done | \
sed -e 's,.*/,,;$(transform)'`; \
dir='$(DESTDIR)$(gendlibdir)'; $(am__uninstall_files_from_dir)
mostlyclean-libtool:
-rm -f *.lo
clean-libtool:
-rm -rf .libs _libs
tags TAGS:
ctags CTAGS:
cscope cscopelist:
distdir: $(DISTFILES)
@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
list='$(DISTFILES)'; \
dist_files=`for file in $$list; do echo $$file; done | \
sed -e "s|^$$srcdirstrip/||;t" \
-e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
case $$dist_files in \
*/*) $(MKDIR_P) `echo "$$dist_files" | \
sed '/\//!d;s|^|$(distdir)/|;s,/[^/]*$$,,' | \
sort -u` ;; \
esac; \
for file in $$dist_files; do \
if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
if test -d $$d/$$file; then \
dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
if test -d "$(distdir)/$$file"; then \
find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
fi; \
if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
fi; \
cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
else \
test -f "$(distdir)/$$file" \
|| cp -p $$d/$$file "$(distdir)/$$file" \
|| exit 1; \
fi; \
done
check-am: all-am
check: check-am
all-am: Makefile $(SCRIPTS)
installdirs:
for dir in "$(DESTDIR)$(gendlibdir)"; do \
test -z "$$dir" || $(MKDIR_P) "$$dir"; \
done
install: install-am
install-exec: install-exec-am
install-data: install-data-am
uninstall: uninstall-am
install-am: all-am
@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
installcheck: installcheck-am
install-strip:
if test -z '$(STRIP)'; then \
$(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
install; \
else \
$(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
"INSTALL_PROGRAM_ENV=STRIPPROG='$(STRIP)'" install; \
fi
mostlyclean-generic:
clean-generic:
distclean-generic:
-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
maintainer-clean-generic:
@echo "This command is intended for maintainers to use"
@echo "it deletes files that may require special tools to rebuild."
clean: clean-am
clean-am: clean-generic clean-libtool mostlyclean-am
distclean: distclean-am
-rm -f Makefile
distclean-am: clean-am distclean-generic
dvi: dvi-am
dvi-am:
html: html-am
html-am:
info: info-am
info-am:
install-data-am: install-gendlibSCRIPTS
install-dvi: install-dvi-am
install-dvi-am:
install-exec-am:
install-html: install-html-am
install-html-am:
install-info: install-info-am
install-info-am:
install-man:
install-pdf: install-pdf-am
install-pdf-am:
install-ps: install-ps-am
install-ps-am:
installcheck-am:
maintainer-clean: maintainer-clean-am
-rm -f Makefile
maintainer-clean-am: distclean-am maintainer-clean-generic
mostlyclean: mostlyclean-am
mostlyclean-am: mostlyclean-generic mostlyclean-libtool
pdf: pdf-am
pdf-am:
ps: ps-am
ps-am:
uninstall-am: uninstall-gendlibSCRIPTS
.MAKE: install-am install-strip
.PHONY: all all-am check check-am clean clean-generic clean-libtool \
cscopelist-am ctags-am distclean distclean-generic \
distclean-libtool distdir dvi dvi-am html html-am info info-am \
install install-am install-data install-data-am install-dvi \
install-dvi-am install-exec install-exec-am \
install-gendlibSCRIPTS install-html install-html-am \
install-info install-info-am install-man install-pdf \
install-pdf-am install-ps install-ps-am install-strip \
installcheck installcheck-am installdirs maintainer-clean \
maintainer-clean-generic mostlyclean mostlyclean-generic \
mostlyclean-libtool pdf pdf-am ps ps-am tags-am uninstall \
uninstall-am uninstall-gendlibSCRIPTS
# Tell versions [3.59,3.63) of GNU make to not export all variables.
# Otherwise a system limit (for SysV at least) may be exceeded.
.NOEXPORT:
+10
View File
@@ -0,0 +1,10 @@
##*****************************************************************************
## $Id: Makefile.am,v 1.4 2004-12-14 21:39:23 achu Exp $
##*****************************************************************************
## Process this file with automake to produce Makefile.in.
##*****************************************************************************
# Don't use ${libdir}, the /lib is a legacy path that must be maintained
gendlibdir = ${prefix}/lib/genders
gendlib_SCRIPTS = gendlib.pl hostlist.pl
EXTRA_DIST = gendlib.pl hostlist.pl
+539
View File
@@ -0,0 +1,539 @@
# Makefile.in generated by automake 1.13.4 from Makefile.am.
# @configure_input@
# Copyright (C) 1994-2013 Free Software Foundation, Inc.
# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.
@SET_MAKE@
VPATH = @srcdir@
am__is_gnu_make = test -n '$(MAKEFILE_LIST)' && test -n '$(MAKELEVEL)'
am__make_running_with_option = \
case $${target_option-} in \
?) ;; \
*) echo "am__make_running_with_option: internal error: invalid" \
"target option '$${target_option-}' specified" >&2; \
exit 1;; \
esac; \
has_opt=no; \
sane_makeflags=$$MAKEFLAGS; \
if $(am__is_gnu_make); then \
sane_makeflags=$$MFLAGS; \
else \
case $$MAKEFLAGS in \
*\\[\ \ ]*) \
bs=\\; \
sane_makeflags=`printf '%s\n' "$$MAKEFLAGS" \
| sed "s/$$bs$$bs[$$bs $$bs ]*//g"`;; \
esac; \
fi; \
skip_next=no; \
strip_trailopt () \
{ \
flg=`printf '%s\n' "$$flg" | sed "s/$$1.*$$//"`; \
}; \
for flg in $$sane_makeflags; do \
test $$skip_next = yes && { skip_next=no; continue; }; \
case $$flg in \
*=*|--*) continue;; \
-*I) strip_trailopt 'I'; skip_next=yes;; \
-*I?*) strip_trailopt 'I';; \
-*O) strip_trailopt 'O'; skip_next=yes;; \
-*O?*) strip_trailopt 'O';; \
-*l) strip_trailopt 'l'; skip_next=yes;; \
-*l?*) strip_trailopt 'l';; \
-[dEDm]) skip_next=yes;; \
-[JT]) skip_next=yes;; \
esac; \
case $$flg in \
*$$target_option*) has_opt=yes; break;; \
esac; \
done; \
test $$has_opt = yes
am__make_dryrun = (target_option=n; $(am__make_running_with_option))
am__make_keepgoing = (target_option=k; $(am__make_running_with_option))
pkgdatadir = $(datadir)/@PACKAGE@
pkgincludedir = $(includedir)/@PACKAGE@
pkglibdir = $(libdir)/@PACKAGE@
pkglibexecdir = $(libexecdir)/@PACKAGE@
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
build_triplet = @build@
host_triplet = @host@
target_triplet = @target@
subdir = compat
DIST_COMMON = $(srcdir)/Makefile.in $(srcdir)/Makefile.am
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/config/ac_cplusplus_extensions.m4 \
$(top_srcdir)/config/ac_debug.m4 \
$(top_srcdir)/config/ac_extension_destdir.m4 \
$(top_srcdir)/config/ac_genders_file.m4 \
$(top_srcdir)/config/ac_java_extenions.m4 \
$(top_srcdir)/config/ac_meta.m4 \
$(top_srcdir)/config/ac_perl_extensions.m4 \
$(top_srcdir)/config/ac_perl_site_arch.m4 \
$(top_srcdir)/config/ac_perl_vendor_arch.m4 \
$(top_srcdir)/config/ac_python_extensions.m4 \
$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
$(ACLOCAL_M4)
mkinstalldirs = $(install_sh) -d
CONFIG_HEADER = $(top_builddir)/config/config.h
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
am__vpath_adj = case $$p in \
$(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
*) f=$$p;; \
esac;
am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
am__install_max = 40
am__nobase_strip_setup = \
srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
am__nobase_strip = \
for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
am__nobase_list = $(am__nobase_strip_setup); \
for p in $$list; do echo "$$p $$p"; done | \
sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
$(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
if (++n[$$2] == $(am__install_max)) \
{ print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
END { for (dir in files) print dir, files[dir] }'
am__base_list = \
sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
am__uninstall_files_from_dir = { \
test -z "$$files" \
|| { test ! -d "$$dir" && test ! -f "$$dir" && test ! -r "$$dir"; } \
|| { echo " ( cd '$$dir' && rm -f" $$files ")"; \
$(am__cd) "$$dir" && rm -f $$files; }; \
}
am__installdirs = "$(DESTDIR)$(gendlibdir)"
SCRIPTS = $(gendlib_SCRIPTS)
AM_V_P = $(am__v_P_@AM_V@)
am__v_P_ = $(am__v_P_@AM_DEFAULT_V@)
am__v_P_0 = false
am__v_P_1 = :
AM_V_GEN = $(am__v_GEN_@AM_V@)
am__v_GEN_ = $(am__v_GEN_@AM_DEFAULT_V@)
am__v_GEN_0 = @echo " GEN " $@;
am__v_GEN_1 =
AM_V_at = $(am__v_at_@AM_V@)
am__v_at_ = $(am__v_at_@AM_DEFAULT_V@)
am__v_at_0 = @
am__v_at_1 =
SOURCES =
DIST_SOURCES =
am__can_run_installinfo = \
case $$AM_UPDATE_INFO_DIR in \
n|no|NO) false;; \
*) (install-info --version) >/dev/null 2>&1;; \
esac
am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) $(LISP)
DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
ACLOCAL = @ACLOCAL@
AMTAR = @AMTAR@
AM_DEFAULT_VERBOSITY = @AM_DEFAULT_VERBOSITY@
AR = @AR@
AUTOCONF = @AUTOCONF@
AUTOHEADER = @AUTOHEADER@
AUTOMAKE = @AUTOMAKE@
AWK = @AWK@
CC = @CC@
CCDEPMODE = @CCDEPMODE@
CFLAGS = @CFLAGS@
CPP = @CPP@
CPPFLAGS = @CPPFLAGS@
CXX = @CXX@
CXXCPP = @CXXCPP@
CXXDEPMODE = @CXXDEPMODE@
CXXFLAGS = @CXXFLAGS@
CYGPATH_W = @CYGPATH_W@
DEFS = @DEFS@
DEPDIR = @DEPDIR@
DLLTOOL = @DLLTOOL@
DSYMUTIL = @DSYMUTIL@
DUMPBIN = @DUMPBIN@
ECHO_C = @ECHO_C@
ECHO_N = @ECHO_N@
ECHO_T = @ECHO_T@
EGREP = @EGREP@
EXEEXT = @EXEEXT@
EXTENSION_DESTDIR = @EXTENSION_DESTDIR@
FGREP = @FGREP@
FORCE_YACC = @FORCE_YACC@
GENDERS_DEFAULT_FILE = @GENDERS_DEFAULT_FILE@
GREP = @GREP@
INSTALL = @INSTALL@
INSTALL_DATA = @INSTALL_DATA@
INSTALL_PROGRAM = @INSTALL_PROGRAM@
INSTALL_SCRIPT = @INSTALL_SCRIPT@
INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
JAR = @JAR@
JAVA = @JAVA@
JAVAC = @JAVAC@
JAVADOC = @JAVADOC@
JAVAH = @JAVAH@
LD = @LD@
LDFLAGS = @LDFLAGS@
LEX = @LEX@
LEXLIB = @LEXLIB@
LEX_OUTPUT_ROOT = @LEX_OUTPUT_ROOT@
LIBGENDERSJNI_VERSION_INFO = @LIBGENDERSJNI_VERSION_INFO@
LIBGENDERSPLUSPLUS_VERSION_INFO = @LIBGENDERSPLUSPLUS_VERSION_INFO@
LIBGENDERS_VERSION_INFO = @LIBGENDERS_VERSION_INFO@
LIBOBJS = @LIBOBJS@
LIBS = @LIBS@
LIBTOOL = @LIBTOOL@
LIPO = @LIPO@
LN_S = @LN_S@
LTLIBOBJS = @LTLIBOBJS@
MAINT = @MAINT@
MAKEINFO = @MAKEINFO@
MANIFEST_TOOL = @MANIFEST_TOOL@
MANPAGE_DEBUG = @MANPAGE_DEBUG@
MKDIR_P = @MKDIR_P@
NM = @NM@
NMEDIT = @NMEDIT@
OBJDUMP = @OBJDUMP@
OBJEXT = @OBJEXT@
OTOOL = @OTOOL@
OTOOL64 = @OTOOL64@
PACKAGE = @PACKAGE@
PACKAGE_BUGREPORT = @PACKAGE_BUGREPORT@
PACKAGE_NAME = @PACKAGE_NAME@
PACKAGE_STRING = @PACKAGE_STRING@
PACKAGE_TARNAME = @PACKAGE_TARNAME@
PACKAGE_URL = @PACKAGE_URL@
PACKAGE_VERSION = @PACKAGE_VERSION@
PATH_SEPARATOR = @PATH_SEPARATOR@
PERL = @PERL@
PERLGENDERS_VERSION = @PERLGENDERS_VERSION@
PERLMAN3EXT = @PERLMAN3EXT@
PERL_ARCH_INSTALL = @PERL_ARCH_INSTALL@
POD2MAN = @POD2MAN@
PROJECT = @PROJECT@
PYTHON = @PYTHON@
PYTHONGENDERS_VERSION = @PYTHONGENDERS_VERSION@
RANLIB = @RANLIB@
RELEASE = @RELEASE@
SED = @SED@
SET_MAKE = @SET_MAKE@
SHELL = @SHELL@
STRIP = @STRIP@
VERSION = @VERSION@
YACC = @YACC@
YFLAGS = @YFLAGS@
abs_builddir = @abs_builddir@
abs_srcdir = @abs_srcdir@
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@
ac_ct_AR = @ac_ct_AR@
ac_ct_CC = @ac_ct_CC@
ac_ct_CXX = @ac_ct_CXX@
ac_ct_DUMPBIN = @ac_ct_DUMPBIN@
am__include = @am__include@
am__leading_dot = @am__leading_dot@
am__quote = @am__quote@
am__tar = @am__tar@
am__untar = @am__untar@
bindir = @bindir@
build = @build@
build_alias = @build_alias@
build_cpu = @build_cpu@
build_os = @build_os@
build_vendor = @build_vendor@
builddir = @builddir@
datadir = @datadir@
datarootdir = @datarootdir@
docdir = @docdir@
dvidir = @dvidir@
exec_prefix = @exec_prefix@
host = @host@
host_alias = @host_alias@
host_cpu = @host_cpu@
host_os = @host_os@
host_vendor = @host_vendor@
htmldir = @htmldir@
includedir = @includedir@
infodir = @infodir@
install_sh = @install_sh@
libdir = @libdir@
libexecdir = @libexecdir@
localedir = @localedir@
localstatedir = @localstatedir@
mandir = @mandir@
mkdir_p = @mkdir_p@
oldincludedir = @oldincludedir@
pdfdir = @pdfdir@
prefix = @prefix@
program_transform_name = @program_transform_name@
psdir = @psdir@
sbindir = @sbindir@
sharedstatedir = @sharedstatedir@
srcdir = @srcdir@
sysconfdir = @sysconfdir@
target = @target@
target_alias = @target_alias@
target_cpu = @target_cpu@
target_os = @target_os@
target_vendor = @target_vendor@
top_build_prefix = @top_build_prefix@
top_builddir = @top_builddir@
top_srcdir = @top_srcdir@
# Don't use ${libdir}, the /lib is a legacy path that must be maintained
gendlibdir = ${prefix}/lib/genders
gendlib_SCRIPTS = gendlib.pl hostlist.pl
EXTRA_DIST = gendlib.pl hostlist.pl
all: all-am
.SUFFIXES:
$(srcdir)/Makefile.in: @MAINTAINER_MODE_TRUE@ $(srcdir)/Makefile.am $(am__configure_deps)
@for dep in $?; do \
case '$(am__configure_deps)' in \
*$$dep*) \
( cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh ) \
&& { if test -f $@; then exit 0; else break; fi; }; \
exit 1;; \
esac; \
done; \
echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu compat/Makefile'; \
$(am__cd) $(top_srcdir) && \
$(AUTOMAKE) --gnu compat/Makefile
.PRECIOUS: Makefile
Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
@case '$?' in \
*config.status*) \
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
*) \
echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe)'; \
cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe);; \
esac;
$(top_builddir)/config.status: $(top_srcdir)/configure $(CONFIG_STATUS_DEPENDENCIES)
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(top_srcdir)/configure: @MAINTAINER_MODE_TRUE@ $(am__configure_deps)
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(ACLOCAL_M4): @MAINTAINER_MODE_TRUE@ $(am__aclocal_m4_deps)
cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(am__aclocal_m4_deps):
install-gendlibSCRIPTS: $(gendlib_SCRIPTS)
@$(NORMAL_INSTALL)
@list='$(gendlib_SCRIPTS)'; test -n "$(gendlibdir)" || list=; \
if test -n "$$list"; then \
echo " $(MKDIR_P) '$(DESTDIR)$(gendlibdir)'"; \
$(MKDIR_P) "$(DESTDIR)$(gendlibdir)" || exit 1; \
fi; \
for p in $$list; do \
if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
if test -f "$$d$$p"; then echo "$$d$$p"; echo "$$p"; else :; fi; \
done | \
sed -e 'p;s,.*/,,;n' \
-e 'h;s|.*|.|' \
-e 'p;x;s,.*/,,;$(transform)' | sed 'N;N;N;s,\n, ,g' | \
$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1; } \
{ d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
if ($$2 == $$4) { files[d] = files[d] " " $$1; \
if (++n[d] == $(am__install_max)) { \
print "f", d, files[d]; n[d] = 0; files[d] = "" } } \
else { print "f", d "/" $$4, $$1 } } \
END { for (d in files) print "f", d, files[d] }' | \
while read type dir files; do \
if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
test -z "$$files" || { \
echo " $(INSTALL_SCRIPT) $$files '$(DESTDIR)$(gendlibdir)$$dir'"; \
$(INSTALL_SCRIPT) $$files "$(DESTDIR)$(gendlibdir)$$dir" || exit $$?; \
} \
; done
uninstall-gendlibSCRIPTS:
@$(NORMAL_UNINSTALL)
@list='$(gendlib_SCRIPTS)'; test -n "$(gendlibdir)" || exit 0; \
files=`for p in $$list; do echo "$$p"; done | \
sed -e 's,.*/,,;$(transform)'`; \
dir='$(DESTDIR)$(gendlibdir)'; $(am__uninstall_files_from_dir)
mostlyclean-libtool:
-rm -f *.lo
clean-libtool:
-rm -rf .libs _libs
tags TAGS:
ctags CTAGS:
cscope cscopelist:
distdir: $(DISTFILES)
@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
list='$(DISTFILES)'; \
dist_files=`for file in $$list; do echo $$file; done | \
sed -e "s|^$$srcdirstrip/||;t" \
-e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
case $$dist_files in \
*/*) $(MKDIR_P) `echo "$$dist_files" | \
sed '/\//!d;s|^|$(distdir)/|;s,/[^/]*$$,,' | \
sort -u` ;; \
esac; \
for file in $$dist_files; do \
if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
if test -d $$d/$$file; then \
dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
if test -d "$(distdir)/$$file"; then \
find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
fi; \
if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
fi; \
cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
else \
test -f "$(distdir)/$$file" \
|| cp -p $$d/$$file "$(distdir)/$$file" \
|| exit 1; \
fi; \
done
check-am: all-am
check: check-am
all-am: Makefile $(SCRIPTS)
installdirs:
for dir in "$(DESTDIR)$(gendlibdir)"; do \
test -z "$$dir" || $(MKDIR_P) "$$dir"; \
done
install: install-am
install-exec: install-exec-am
install-data: install-data-am
uninstall: uninstall-am
install-am: all-am
@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
installcheck: installcheck-am
install-strip:
if test -z '$(STRIP)'; then \
$(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
install; \
else \
$(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
"INSTALL_PROGRAM_ENV=STRIPPROG='$(STRIP)'" install; \
fi
mostlyclean-generic:
clean-generic:
distclean-generic:
-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
maintainer-clean-generic:
@echo "This command is intended for maintainers to use"
@echo "it deletes files that may require special tools to rebuild."
clean: clean-am
clean-am: clean-generic clean-libtool mostlyclean-am
distclean: distclean-am
-rm -f Makefile
distclean-am: clean-am distclean-generic
dvi: dvi-am
dvi-am:
html: html-am
html-am:
info: info-am
info-am:
install-data-am: install-gendlibSCRIPTS
install-dvi: install-dvi-am
install-dvi-am:
install-exec-am:
install-html: install-html-am
install-html-am:
install-info: install-info-am
install-info-am:
install-man:
install-pdf: install-pdf-am
install-pdf-am:
install-ps: install-ps-am
install-ps-am:
installcheck-am:
maintainer-clean: maintainer-clean-am
-rm -f Makefile
maintainer-clean-am: distclean-am maintainer-clean-generic
mostlyclean: mostlyclean-am
mostlyclean-am: mostlyclean-generic mostlyclean-libtool
pdf: pdf-am
pdf-am:
ps: ps-am
ps-am:
uninstall-am: uninstall-gendlibSCRIPTS
.MAKE: install-am install-strip
.PHONY: all all-am check check-am clean clean-generic clean-libtool \
cscopelist-am ctags-am distclean distclean-generic \
distclean-libtool distdir dvi dvi-am html html-am info info-am \
install install-am install-data install-data-am install-dvi \
install-dvi-am install-exec install-exec-am \
install-gendlibSCRIPTS install-html install-html-am \
install-info install-info-am install-man install-pdf \
install-pdf-am install-ps install-ps-am install-strip \
installcheck installcheck-am installdirs maintainer-clean \
maintainer-clean-generic mostlyclean mostlyclean-generic \
mostlyclean-libtool pdf pdf-am ps ps-am tags-am uninstall \
uninstall-am uninstall-gendlibSCRIPTS
# Tell versions [3.59,3.63) of GNU make to not export all variables.
# Otherwise a system limit (for SysV at least) may be exceeded.
.NOEXPORT:
+490
View File
@@ -0,0 +1,490 @@
#############################################################################
# $Id: gendlib.pl,v 1.13 2010-02-02 00:04:34 chu11 Exp $
#############################################################################
# Copyright (C) 2007-2019 Lawrence Livermore National Security, LLC.
# Copyright (C) 2001-2007 The Regents of the University of California.
# Produced at Lawrence Livermore National Laboratory (cf, DISCLAIMER).
# Written by Jim Garlick <garlick@llnl.gov>.
# UCRL-CODE-2003-004.
#
# This file is part of Genders, a cluster configuration database and
# rdist preprocessor.
# For details, see <http://www.llnl.gov/linux/genders/>.
#
# Genders is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# Genders is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along
# with Genders. If not, see <http://www.gnu.org/licenses/>.
#############################################################################
package Genders;
use strict;
use vars qw($included $debug $havePSSP $handle);
use vars qw($init_hname_called $hname);
use vars qw($altAttr $clusterAttr);
use Libgenders;
if (!$included) {
$included = 1;
##
## Package globals
##
$debug = 0;
# See note in to_altnames().
$havePSSP = (-d "/usr/lpp/ssp");
if ($havePSSP) {
require "/admin/lib/sdrlib.pl";
}
$altAttr = "altname";
$clusterAttr = "cluster";
$hname = ""; # short hostname
$init_hname_called = 0;
$handle = undef; # genders handle
##
## Subroutines
##
# initialize package
# $path (IN) [optional] path to genders file
# $rv (RETURN) 0 on failure opening genders, 1 on success
sub init
{
my (@alist, $attr, $node, $blob, $gendfile, $ret);
if (@_) {
$gendfile = $_[0];
} else {
$gendfile = Libgenders->GENDERS_DEFAULT_FILE
}
$handle = Libgenders->genders_handle_create();
if (!defined($handle)) {
$debug && print "Error, genders_handle_create()\n";
return 0;
}
$ret = $handle->genders_load_data($gendfile);
if ($ret == -1) {
$debug && print "Error, genders_load_data()\n";
$handle = undef;
return 0;
}
# initialize hostname
if (!$init_hname_called) {
$ret = init_hname();
if ($ret == 0) {
$handle = undef;
return 0;
}
}
$debug && print("init called\n");
return 1;
}
# cache the local hostname
sub init_hname
{
# get 'my' hostname
$hname = $handle->genders_getnodename();
if (!defined $hname) {
print "Error, genders_getnodename()\n";
return 0;
}
$init_hname_called = 1;
$debug && print("init_hname called\n");
return 1;
}
# determine if host has attribute
# $attr (IN) attribute
# $node (IN) [optional] hostname
# $found (RETURN) 0 if not found, 1 if found
sub hasattr
{
if (!defined $handle) {
init();
if (!defined $handle) {
return 0;
}
}
my $attr = shift(@_);
my $node = (@_) ? shift(@_) : $hname;
my ($ret);
if (defined($attr)) {
$ret = $handle->genders_testattr($attr, $node);
if ($ret == -1) {
$debug && print "Error, genders_testattr()\n";
return 0;
}
else {
return $ret;
}
}
return 0;
}
# return value of attribute held by host
# $attr (IN) attribute
# $node (IN) [optional] hostname
# $value (RETURN) value or null if (no value or node does not have attr)
sub getattrval
{
if (!defined $handle) {
init();
if (!defined $handle) {
return "";
}
}
my $attr = shift(@_);
my $node = (@_) ? shift(@_) : $hname;
my ($val);
if (defined($attr)) {
$val = $handle->genders_getattrval($attr, $node);
if (!defined($val)) {
$debug && print "Error, genders_getattrval()\n";
return "";
}
else {
return $val;
}
}
return "";
}
# get list of attributes held by node
# $node (IN) [optional] hostname
# @attrs (RETURN) list of attributes
sub getattr
{
if (!defined $handle) {
init();
if (!defined $handle) {
return ();
}
}
my $node = (@_) ? shift(@_) : $hname;
my ($attrs, $temp);
$temp = $handle->genders_getattr($node);
if (!defined($temp)) {
$debug && print "Error, genders_getattr()\n";
return ();
}
else {
($attrs) = @$temp;
return @$attrs;
}
}
# get all attributes in genders file
# @attrs (RETURN) list of attributes
sub getallattr
{
if (!defined $handle) {
init();
if (!defined $handle) {
return ();
}
}
my ($attr);
$attr = $handle->genders_getattr_all();
if (!defined($attr)) {
$debug && print "Error, genders_getattr_all()\n";
return ();
}
else {
return @$attr;
}
}
# get list of nodes that have attribute
# $attr (IN) attribute
# @nodes (RETURN) list of nodes
sub getnode
{
if (!defined $handle) {
init();
if (!defined $handle) {
return ();
}
}
my $attr = shift(@_);
my (@attrtemp, $nodes);
if (defined($attr)) {
if ($attr =~ /=/) {
#strip attribute name and value
@attrtemp = split(/=/, $attr);
if (@attrtemp != 2) {
return ();
}
else {
$nodes = $handle->genders_getnodes($attrtemp[0], $attrtemp[1]);
}
}
else {
$nodes = $handle->genders_getnodes($attr);
}
}
else {
$nodes = $handle->genders_getnodes();
}
if (!defined($nodes)) {
$debug && print "Error, genders_getnodes()\n";
return ();
}
else {
return @$nodes;
}
}
# Get a copy of hash of attributes -> node lists.
# \%nodes (OUT) node hash
sub get_node_hash
{
my ($nodes) = (@_);
my (%nodes, $attrs, $attr, $attrnodes);
if (!defined $handle) {
init();
if (!defined $handle) {
%{$nodes} = ();
return;
}
}
# must construct hash
$attrs = $handle->genders_getattr_all();
if (!defined($attrs)) {
$debug && print "Error, genders_getattr_all()\n";
%nodes = ();
}
elsif (@$attrs == 0) {
%nodes = ();
}
else {
foreach $attr (@$attrs) {
$attrnodes = $handle->genders_getnodes($attr);
if (!defined($attrnodes)) {
$debug && print "Error, genders_getnodes()\n";
%nodes = ();
last;
}
else {
@{$nodes{$attr}} = @$attrnodes;
}
}
}
%{$nodes} = %nodes;
}
# initialize list of clusters
# $path (IN) [optional] path to clusters file
# $rv (RETURN) 0 on failure opening attributes, 1 on success
sub init_clusters
{
# clusters file now removed, just return 1
return(1);
}
# get a copy of the list of clusters
# $rv (RETURN) "" on failure, cluster name on success
# - to remain backwards compatible, a list containing the
# cluster name will be returned, not just the cluster name.
sub get_clusters
{
if (!defined $handle) {
init();
if (!defined $handle) {
return "";
}
}
my (@cluster, $cluster);
$cluster = $handle->genders_getattrval($clusterAttr);
if (!defined($cluster)) {
$debug && print "Error, genders_getattrval()\n";
return "";
}
@cluster = ($cluster);
return @cluster;
}
# evaluate expression involving genders attributes
# (assume any non-numeric token is a genders attribute; turn this into
# a boolean variable with value assigned by hasattr(), then evaluate
# the expression and return the result)
# $exp (IN) expression to evaluate
# $node (IN) [optional] hostname, use local host if unspecified
# $rv (RETURN) result of expression evaluation
sub gendexp
{
if (!defined $handle) {
init();
if (!defined $handle) {
return 0;
}
}
my $exp = shift(@_);
my $node = (@_) ? shift(@_) : $hname;
my ($var, $pro, %vars, $ret);
if (!$exp) {
return $exp;
}
$pro = "";
foreach $var (split(/[\!\+\-\*\/(\s\(\&\|)]+/, $exp)) {
$var =~ s/\s+//g;
next if (!$var || $var =~ /^[0-9]+$/);
$ret = $handle->genders_testattr($var, $node);
if ($ret == -1) {
$debug && print "Error, genders_testattr()\n";
return 0;
}
elsif ($ret) {
$pro .= "my \$$var = 1; ";
} else {
$pro .= "my \$$var = 0; ";
}
$vars{$var}++;
}
foreach $var (keys %vars) {
$exp =~ s/$var/\$$var/g;
}
if ($debug) {
printf("evaluating { %s } for host %s\n", $pro . $exp, $node);
}
no strict;
return(eval($pro . $exp));
use strict;
}
# Convert "genders names" to an alternate names. On an SP, the genders
# name is assumed to be the SDR initial_hostname, and the alternate name
# is the reliable_hostname. On other systems, the alternate hostname is
# stored in the genders for each node as the value of the "altname" attribute.
# @inList (IN) list of genders names
# RETURN list of alternate names
# NOTE: names in the input that cannot be converted are preserved in the output
sub to_altnames
{
if (!defined $handle) {
init();
if (!defined $handle) {
return ();
}
}
my (@inList) = @_;
my (@outList, $altName, $name);
foreach $name (@inList) {
($name) = split(/\./, $name); # shorten name
if ($havePSSP) {
$altName = Sdr::nn2ename(Sdr::sname2nn($name));
} else {
$altName = $handle->genders_getattrval($altAttr, $name);
if (!defined($altName) &&
$handle->genders_errnum() != $handle->GENDERS_ERR_NOTFOUND) {
$debug && print "Error, genders_getattrval()\n";
return ();
}
}
push(@outList, $altName ? $altName : $name);
}
return(@outList);
}
# perform the inverse of to_altnames()
# @inList (IN) list of altnernate names
# RETURN list of genders names
# NOTE: names in the input that cannot be converted are preserved in the output
sub to_gendnames
{
if (!defined $handle) {
init();
if (!defined $handle) {
return ();
}
}
my (@inList) = @_;
my (@outList, $altName, $name, $tmp, $nodes, $val);
foreach $altName (@inList) {
$name = "";
($altName) = split(/\./, $altName); # shorten name
if ($havePSSP) {
$name = Sdr::nn2sname(Sdr::ename2nn($altName));
} else {
$nodes = $handle->genders_getnodes($altAttr);
if (!defined($nodes)) {
$debug && print "Error, genders_getnodes()\n";
return ();
}
foreach $tmp (@$nodes) {
$val = $handle->genders_getattrval($altAttr, $tmp);
if (!defined($val)) {
$debug && print "Error, genders_getattrval()\n";
return ();
}
if ($val eq $altName) {
$name = $tmp;
last;
}
}
}
push(@outList, $name ? $name : $altName);
}
return(@outList);
}
} # $included
1; # return a true value...
+368
View File
@@ -0,0 +1,368 @@
#############################################################################
# $Id: hostlist.pl,v 1.9 2010-02-02 00:04:34 chu11 Exp $
#############################################################################
# Copyright (C) 2007-2019 Lawrence Livermore National Security, LLC.
# Copyright (C) 2001-2007 The Regents of the University of California.
# Produced at Lawrence Livermore National Laboratory (cf, DISCLAIMER).
# Written by Jim Garlick <garlick@llnl.gov>.
# UCRL-CODE-2003-004.
#
# This file is part of Genders, a cluster configuration database and
# rdist preprocessor.
# For details, see <http://www.llnl.gov/linux/genders/>.
#
# Genders is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# Genders is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along
# with Genders. If not, see <http://www.gnu.org/licenses/>.
#############################################################################
#
# Routines for reading, normalizing, and displaying lists of hosts.
#
package Hostlist;
use strict;
use Carp;
use Genders;
if (!$Hostlist::included) {
$Hostlist::included = 1;
# compress will generate a quadrics-style range if this is > 0
$Hostlist::quadrics_ranges = 0;
# Construct node list from hostlist file
# $fileName (IN) hostlist filename
# RETURN list of nodes
sub mk_file
{
my ($fileName) = @_;
my (@targetNodes);
if (open(FILE, "< $fileName")) {
while (<FILE>) {
chomp;
s/\*.*$//; # strip comments (*)
s/\!.*$//; # strip comments (!)
s/^\s+.*//; # strip leading spaces
s/.*\s+$//; # strip trailing spaces
next if (/^\s*$/); # skip blank lines
push(@targetNodes, $_);
}
close(FILE);
}
return @targetNodes;
}
# Construct node list from genders attribute name
# $attrName (IN) attribute name
# RETURN list of nodes
sub mk_gend
{
my ($attrName) = @_;
my $obj;
$obj = Genders->new();
return $obj->getnodes($attrName);
}
# Construct node list from command line
# $cmdLine (IN) comma-separated list of nodes
# RETURN list of nodes
sub mk_cmdline
{
my ($cmdLine) = @_;
my (@targetNodes);
@targetNodes = split(/,/, $cmdLine);
return @targetNodes;
}
# Convert list of hostnames from reliable_hostname to initial_hostname.
# OK if already initial_hostname.
# @inList (IN) list of reliable_hostnames
# RETURN list of initial_hostnames
sub to_initial
{
my (@inList) = @_;
my (@outList, $node, $iname);
foreach $node (@inList) {
($node) = split(/\./, $node); # shorten name
#$iname = Sdr::nn2sname(Sdr::ename2nn($node)); # convert
push(@outList, $iname ? $iname : $node);
}
return @outList;
}
# Convert list of hostnames from initial_hostname to reliable_hostname.
# OK if already reliable_hostname.
# @inList (IN) list of initial_hostnames
# RETURN list of reliable_hostnames
sub to_reliable
{
my (@inList) = @_;
my (@outList, $node, $rname);
foreach $node (@inList) {
($node) = split(/\./, $node); # shorten name
#$rname = Sdr::nn2ename(Sdr::sname2nn($node)); # convert
push(@outList, $rname ? $rname : $node);
}
return @outList;
}
# Detect shell metacharacters in a hostlist entry.
# $line (IN) hostlist line
# RETURN true if metachars found, false otherwise
sub detect_metachar
{
my ($line) = @_;
return ($line =~ /(\;|\||\&)/);
}
# expand()
# turn a hostname range into a list of hostnames. Try to autodetect whether
# a quadrics-style range or a normal hostname range was passed in.
#
sub expand
{
my ($list) = @_;
# matching "[" "]" pair with stuff inside will be considered a quadrics
# range:
if ($list =~ /[^[]*\[.+\]/) {
# quadrics ranges are separated by whitespace in RMS -
# try to support that here
$list =~ s/\s+/,/g;
#
# Replace ',' chars internal to "[]" with ':"
#
while ($list =~ s/(\[[^\]]*),([^\[]*\])/$1:$2/) {}
return map { expand_quadrics_range($_) } split /,/, $list;
} else {
return map {
s/(\w*?)(\d+)-(\w*?)(\d+)/"$2".."$4"/
||
s/(.+)/""/;
map {"$1$_"} eval;
} split /,/, $list;
}
}
# expand_quadrics_range
#
# expand nodelist in quadrics form
#
sub expand_quadrics_range
{
my ($list) = @_;
my ($pfx, $ranges) = split(/[\[\]]/, $list);
return $list if (!defined $ranges);
return map {"$pfx$_"}
map { s/(\d+)-(\d+)/"$1".."$2"/; eval }
split(/,|:/, $ranges);
}
# compress_to_quadrics
#
# compress a list of nodes to into a quadrics-style list of ranges
#
sub compress_to_quadrics
{
my (@list) = @_;
local $Hostlist::quadrics_ranges = 1;
return compress(@list) if @list;
}
# Turn long lists of nodes with numeric suffixes into ranges where possible
# optionally return a Quadrics-style range if $quadrics_ranges is nonzero.
#
# @nodes (IN) flat list of nodes
# RETURN list of nodes possibly containing ranges
#
sub compress {
my %rng = comp2(@_);
my @list = ();
local $"=",";
if (!$Hostlist::quadrics_ranges) {
foreach my $k (keys %rng) {
@{$rng{$k}} = map { "$k$_" } @{$rng{$k}};
}
@list = map { @{$rng{$_}} } sort keys %rng;
} else {
@list = map { $_ .
(@{$rng{$_}}>1 || ${$rng{$_}}[0] =~ /-/ ?
"[@{$rng{$_}}]" :
"@{$rng{$_}}"
)
} sort keys %rng;
}
return wantarray ? @list : "@list";
}
# comp2():
#
# takes a list of names and returns a hash of arrays, indexed by name prefix,
# each containing a list of numerical ranges describing the initial list.
#
# e.g.: %hash = comp2(lx01,lx02,lx03,lx05,dev0,dev1,dev21)
# will return:
# $hash{"lx"} = ["01-03", "05"]
# $hash{"dev"} = ["0-1", "21"]
#
sub comp2
{
my (%i) = ();
my (%s) = ();
# turn off warnings here to avoid perl complaints about
# uninitialized values for members of %i and %s
local ($^W) = 0;
push(@{
$s{$$_[0]}[ (
$s{ $$_[0] }[ $i{$$_[0]} ]
[$#{$s{$$_[0]}[$i{$$_[0]}]}] == ($$_[1]-1)
) ? $i{$$_[0]} : ++$i{$$_[0]}
]
}, ($$_[1])
) for map { [/(.*?)(\d*)$/] } sortn(@_);
for my $key (keys %s) {
@{$s{$key}} =
map { $#$_>0 ? "$$_[0]-$$_[$#$_]" : @{$_} } @{$s{$key}};
}
return %s;
}
# uniq: remove duplicates from a hostlist
#
sub uniq
{
my %seen = ();
grep { !$seen{$_}++ } @_;
}
# intersect(\@a, \@b): return the intersection of two lists,
# i.e. those hosts in both @a and @b.
# IN : two array refs \@a , \@b
# OUT: flat list of hosts in =both= @a and @b
sub intersect
{
my ($a, $b) = @_;
(ref $a && ref $b) or
croak "Error: arguments to intersect must be references";
my @result = ();
for my $hn (@$a) {
push (@result, grep { $_ eq $hn } @$b);
}
return @result;
}
# union(\@a, \@b): return the union of two lists
# i.e. list of hosts from both @a and @b
# IN : two array refs \@a, \@b
# OUT: flat list of hosts from @a and @b
sub union
{
my ($a, $b) = @_;
(ref $a && ref $b) or
croak "Error: arguments to union must be references";
return uniq(@$a, @$b);
}
# diff(\@a, \@b): return the list of hosts in @a that are not in @b
# i.e. hosts in @a - hosts in @b
# IN : two array refs \@a, \@b
# OUT: flat list of hosts in @a that are not in @b
sub diff
{
my ($a, $b) = @_;
(ref $a && ref $b) or
croak "Error: arguments to diff must be references";
my @result = ();
for my $hn (@$a) {
push(@result, $hn) if (!grep { $_ eq $hn } @$b);
}
return @result;
}
# xor(\@a, \@b): exclusive OR hosts in @a and @b
# i.e. those hosts in @a and @b but not in both
# IN : two array refs \@a, \@b
# OUT: flat list of hosts in @a and @b but not in both
sub xor
{
my ($a, $b) = @_;
(ref $a && ref $b) or
croak "Error: arguments to xor must be references";
return (diff($a, $b), diff($b, $a));
}
# within(\@a, \@b): true if all hosts in @a are in @b
# i.e. is @a a subset of @b?
# IN : two array refs \@a, \@b
# OUT: true if @a is a subset of @b, false otherwise.
sub within
{
my ($a, $b) = @_;
(ref $a && ref $b) or
croak "Error: arguments to within must be references";
return (intersect($a, $b) == @$a)
}
# same(\@a, \@b) : true if @a and @b contain the exact same hosts
# i.e. are @a and @b the same list?
# IN : two array refs \@a, \@b
# OUT: true if @a is same as @b, false otherwise
sub same
{
my ($a, $b) = @_;
(ref $a && ref $b) or
croak "arguments to same must be references";
return (within($a, $b) && within($b, $a));
}
# sortn:
#
# sort a group of alphanumeric strings by the last group of digits on
# those strings, if such exists (good for numerically suffixed host lists)
#
sub sortn
{
map {$$_[0]} sort {($$a[1]||0)<=>($$b[1]||0)} map {[$_,/(\d*)$/]} @_;
}
} # Hostlist::included
1; # return a true value...